// file: StringStackC.java
// author: Bob Muller
// date: January 23, 2014
//
// An implementation of a simple stack ADT.
//
import java.util.*;

public class StringStackC implements StringStack {
    
    private static final int CAPACITY = 100;
    
    // Instance variables.
    //
    private int N;                // The number of Strings in the stack.
    private String[] theStack;
    
    // A constructor.
    //
    public StringStackC() {
        this.N = 0;
        this.theStack = new String[CAPACITY];
    }
    
    public void push(String s) {
     
        if(this.N == CAPACITY)
            throw new RuntimeException("Stack Overflow.");
        else 
            this.theStack[N++] = s;
    }
    
    public String pop() {
        if (this.isEmpty())
            throw new NoSuchElementException("Stack Underflow.");
        else {
            String ts = this.theStack[this.N - 1];
            this.theStack[this.N - 1] = null;
            this.N = this.N - 1;
            return ts;
        }       
    }
    public boolean isEmpty() { return this.N == 0; }
    
    public String toString() { 
        StringBuilder sb = new StringBuilder();
        
        for(int i = this.N - 1; i >= 0; i--)
            sb.append(this.theStack[i].toString() + "\n");
        
        return sb.toString();
    }
    
    public static void main(String[] args) {
    
        // Unit test. Reads a Strings from stdin then prints them
        // in reverse order.
        //
        StringStack ss = new StringStackC();
        
        while(!StdIn.isEmpty()) {    
            String name = StdIn.readString();
            ss.push(name);
        }
        while(!ss.isEmpty()) {
            String name = ss.pop();
            System.out.println(name);
        }   
    }
}